// `FC@ɂnbVi\[XFL[͎j

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Member.h"
#include "ChainHash.h"

/*--- nbV֐ikeỹnbVlԂj---*/
static int hash(const char *key, int size)
{
	unsigned long h = 0;

	while (*key)
		h += *(key++);
	return h % size;
}

/*--- m[h̊eoɒlݒ ----*/
static void SetNode(Node *n, const Member *x, const Node *next)
{
	n->data = *x;		// f[^
	n->next = next;		// 㑱|C^
}

/*--- nbV\̏ ---*/
int Initialize(ChainHash *h, int size)
{
	if ((h->table = calloc(size, sizeof(Node *))) == NULL) {
		h->size = 0;
		return 0;
	}

	h->size = size;
	for (int i = 0; i < size; i++)	// ׂẴoPbgɂ
		h->table[i] = NULL;

	return 1;
}

/*--- T ---*/
Node *Search(const ChainHash *h, const Member *x)
{
	int key = hash(x->name, h->size);	// Tf[^̃nbVl
	Node *p = h->table[key];			// ڃm[h

	while (p != NULL) {
		if (!strcmp(p->data.name, x->name))	// T
			return p;
		p = p->next;					// 㑱m[hɒ
	}
	return NULL;						// Ts
}

/*--- f[^̒ǉ ---*/
int Add(ChainHash *h, const Member *x)
{
	int key = hash(x->name, h->size);	// ǉf[^̃nbVl
	Node *p = h->table[key];			// ڃm[h
	Node *temp;

	while (p != NULL) {
		if (!strcmp(p->data.name, x->name))		// ̃L[͓o^
			return 1;					// ǉs
		p = p->next;					// 㑱m[hɒ
	}
	if ((temp = calloc(1, sizeof(Node))) == NULL)
		return 2;
	SetNode(temp, x, h->table[key]);	// ǉm[hɒlݒ
	h->table[key] = temp;

	return 0;							// ǉ
}

/*--- f[^̍폜 ---*/
int Remove(ChainHash *h, const Member *x)
{
	int  key = hash(x->name, h->size);	// 폜f[^̃nbVl
	Node *p = h->table[key];			// ڃm[h
	Node **pp = &h->table[key];			// ڃm[hւ̃|C^

	while (p != NULL) {
		if (!strcmp(p->data.name, x->name))	{	// 
			*pp = p->next;
			free(p);					// 
			return 0;					// 폜
		}
		pp = &p->next;
		p = p->next;					// 㑱m[hɒ
	}

	return 1;							// 폜si݂Ȃj
}

/*--- nbV\_v ---*/
void Dump(const ChainHash *h)
{
	for (int i = 0; i < h->size; i++) {
		Node *p = h->table[i];
		printf("%02d  ", i);
		while (p != NULL) {
			printf(" %d (%s)  ", p->data.no, p->data.name);
			p = p->next;
		}
		putchar('\n');
	}
}

/*--- Sf[^̍폜 ---*/
void Clear(ChainHash *h)
{
	for (int i = 0; i < h->size; i++) {
		Node *p = h->table[i];			// ڃm[h
		while (p != NULL) {
			Node *next = p->next;
			free(p);					// ڃm[hp̋L
			p = next;					// 㑱m[hɒ
		}
		h->table[i] = NULL;
	}
}

/*--- nbV\n ---*/
void Terminate(ChainHash *h)
{
	Clear(h);				// Sf[^폜
	free(h->table);			// nbV\pz̋L
	h->size = 0;			// nbV\̗eʂNA
}
