// K4-6 int^fbNIntDequeuei\[Xj

#include <stdio.h>
#include <stdlib.h>
#include "IntDequeue.h"

/*--- fbN̏ ---*/
int Initialize(IntDequeue *q, int max)
{
	q->num = q->front = q->rear = 0;
	if ((q->que = calloc(max, sizeof(int))) == NULL) {
		q->max = 0;							// z̐Ɏs
		return -1;
	}
	q->max = max;
	return 0;
}

/*--- fbN̐擪Ƀf[^GL[ ---*/
int EnqueFront(IntDequeue *q, int x)
{
	if (q->num >= q->max)
		return -1;							// fbN͖t
	else {
		q->num++;
		if (--q->front < 0)
			q->front = q->max - 1;
		q->que[q->front] = x;
		return 0;
	}
}

/*--- fbN̖Ƀf[^GL[ ---*/
int EnqueRear(IntDequeue *q, int x)
{
	if (q->num >= q->max)
		return -1;							// fbN͖t
	else {
		q->num++;
		q->que[q->rear++] = x;
		if (q->rear == q->max)
			q->rear = 0;
		return 0;
	}
}

/*--- fbN̐擪f[^fL[ ---*/
int DequeFront(IntDequeue *q, int *x)
{
	if (q->num <= 0)						// fbN͋
		return -1;
	else {
		q->num--;
		*x = q->que[q->front++];
		if (q->front == q->max)
			q->front = 0;
		return 0;
	}
}

/*--- fbN̖f[^fL[ ---*/
int DequeRear(IntDequeue *q, int *x)
{
	if (q->num <= 0)						// fbN͋
		return -1;
	else {
		q->num--;
		if (--q->rear < 0)
			q->rear = q->max - 1;
		*x = q->que[q->rear];
		return 0;
	}
}

/*--- fbN̐擪f[^s[N ---*/
int PeekFront(const IntDequeue *q, int *x)
{
	if (q->num <= 0)						// fbN͋
		return -1;
	*x = q->que[q->front];
	return 0;
}

/*--- fbN̖f[^s[N ---*/
int PeekRear(const IntDequeue *q, int *x)
{
	if (q->num <= 0)						// fbN͋
		return -1;
	*x = q->que[q->rear];
	return 0;
}

/*--- Sf[^폜 ---*/
void Clear(IntDequeue *q)
{
	q->num = q->front = q->rear = 0;
}

/*--- fbN̗e ---*/
int Capacity(const IntDequeue *q)
{
	return q->max;
}

/*--- fbNɒ~Ăf[^ ---*/
int Size(const IntDequeue *q)
{
	return q->num;
}

/*--- fbN͋ ---*/
int IsEmpty(const IntDequeue *q)
{
	return q->num <= 0;
}

/*--- fbN͖t ---*/
int IsFull(const IntDequeue *q)
{
	return q->num >= q->max;
}

/*--- fbN̒T ---*/
int Search(const IntDequeue *q, int x)
{
	int idx;

	for (int i = 0; i < q->num; i++) {
		if (q->que[idx = (i + q->front) % q->max] == x)
			return idx;		// T
	}
	return -1;				// Ts
}

/*--- fbN̒Ti_IYԋpj---*/
int Search2(const IntDequeue *q, int x)
{
	for (int i = 0; i < q->num; i++) {
		if (q->que[(i + q->front) % q->max] == x)
			return i;		// T
	}
	return -1;				// Ts
}

/*--- Sf[^̕\ ---*/
void Print(const IntDequeue *q)
{
	for (int i = 0; i < q->num; i++)
		printf("%d ", q->que[(i + q->front) % q->max]);
	putchar('\n');
}

/*--- fbŇn ---*/
void Terminate(IntDequeue *q)
{
	if (q->que != NULL)
		free(q->que);							// zj
	q->max = q->num = q->front = q->rear = 0;
}
