// K9-1`K9-2@QT؁i\[Xj

#include <stdio.h>
#include <stdlib.h>
#include "Member.h"
#include "BinTree.h"

/*--- ̃m[h𓮓IɊm ---*/
static BinNode *AllocBinNode(void)
{
	return calloc(1, sizeof(BinNode));
}

/*--- m[h̊eoɒlݒ ----*/
static void SetBinNode(BinNode *n, const Member *x, const BinNode *left,
													const BinNode *right)
{
	n->data  = *x;			// f[^
	n->left  = left;		// |C^
	n->right = right;		// E|C^
}

/*--- T ---*/
BinNode *Search(BinNode *p, const Member *x)
{
	int cond;

	if (p == NULL)
		return NULL;									// Ts
	else if ((cond = MemberNoCmp(x, &p->data)) == 0)
		return p;										// T
	else if (cond < 0)
		Search(p->left,  x);				// ؂T
	else
		Search(p->right, x);				// E؂T
}

/*--- m[h} ---*/
BinNode *Add(BinNode *p, const Member *x)
{
	int cond;

	if (p == NULL) {
		p = AllocBinNode();
		SetBinNode(p, x, NULL, NULL);
	} else if ((cond = MemberNoCmp(x, &p->data)) == 0)
		printf("yG[z%d͊ɓo^Ă܂B\n", x->no);
	else if (cond < 0)
		p->left  = Add(p->left, x);
	else
		p->right = Add(p->right, x);
	return p;
}

/*--- m[h폜 ---*/
int Remove(BinNode **root, const Member *x)
{
	BinNode *next, *temp;
	BinNode **left;
	BinNode **p = root;

	while (1) {
		int cond;
		if (*p == NULL) {
			printf("yG[z%d͓o^Ă܂B\n", x->no);
			return -1;		// ̃L[݂͑Ȃ
		} else if ((cond = MemberNoCmp(x, &(*p)->data)) == 0)
			break;							// T
		else if (cond < 0)
			p = &((*p)->left);				// ؂T
		else
			p = &((*p)->right);				// E؂T
	}
	if ((*p)->left == NULL)
		next = (*p)->right;
	else {
		left = &((*p)->left);
		while ((*left)->right != NULL)
			left = &(*left)->right;
		next = *left;
		*left = (*left)->left;
		next->left  = (*p)->left;
		next->right = (*p)->right;
	}
	temp = *p;
	*p = next;
	free(temp);

	return 0;
}

/*--- Sm[h̃f[^\ ---*/
void PrintTree(const BinNode *p)
{
	if (p != NULL) {
		PrintTree(p->left);
		PrintLnMember(&p->data);
		PrintTree(p->right);
	}
}

/*--- Sm[hL[l̍~ɕ\ ---*/
void PrintTreeReverse(const BinNode *p)
{
	if (p != NULL) {
		PrintTreeReverse(p->right);
		PrintLnMember(&p->data);
		PrintTreeReverse(p->left);
	}
}

/*--- ŏ̃L[lm[h擾 ---*/
BinNode *GetMinNode(const BinNode *p)
{
	if (p == NULL)
		return NULL;
	else {
		while (p->left != NULL)
			p = p->left;
		return p;
	}
}

/*--- ő̃L[lm[h擾 ---*/
BinNode *GetMaxNode(const BinNode *p)
{
	if (p == NULL)
		return NULL;
	else {
		while (p->right != NULL)
			p = p->right;
		return p;
	}
}

/*--- Sm[h̍폜 ---*/
void FreeTree(BinNode *p)
{
	if (p != NULL) {
		FreeTree(p->left);
		FreeTree(p->right);
		free(p);
	}
}
